/**********************************************************************
  VKvZX(}V\[X)̒ǉ
  $Id: create_proc.c,v 1.6 2002/11/29 18:13:30 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "sim_io.h"
#include "op_scemu.h"

int	create_proc( struct PROCESS_LIST *proc_list, int memsize )
{
int id ;
struct MACHINE_RESOURCE *mres ;
int res ; 

  proc_list->cur_id++ ;
  id   = proc_list->cur_id ;
  mres = &proc_list->proc[id] ;

  if( sc_emu_mode==LINUXPPC ){
    if( mres->mem[LINUX_TEXT_SEG_TOP]!=NULL ){
      free(mres->mem[LINUX_TEXT_SEG_TOP]) ;
      mres->mem[LINUX_TEXT_SEG_TOP]=NULL ;
      mres->mem_size[LINUX_TEXT_SEG_TOP]=0 ;
    }
    res=memal( mres, LINUX_TEXT_SEG_TOP,
	       default_linux_textsize, MEM_ATTR_NORMAL ) ;
    if( res!=NORMAL_EXIT ){
      SYSMSG("Can not allocate memory(seg=0x%02x size=%d)\n",
	     LINUX_TEXT_SEG_TOP, default_linux_textsize ) ;
      return(MEM_ALLOC_ERROR) ;
    }
  }

  
  if( mres->mem[TEXT_SEG_TOP]!=NULL ){
    free(mres->mem[TEXT_SEG_TOP]) ;
    mres->mem[TEXT_SEG_TOP]=NULL ;
    mres->mem_size[TEXT_SEG_TOP]=0 ;
  }
  res=memal( mres, TEXT_SEG_TOP, memsize, MEM_ATTR_NORMAL ) ;
  if( res!=NORMAL_EXIT ){
    SYSMSG("Can not allocate memory(seg=0x%02x size=%d)\n",
	   TEXT_SEG_TOP, memsize ) ;
    return(MEM_ALLOC_ERROR) ;
  }


  if( mres->mem[HEAP_SEG_TOP]!=NULL ){
    free(mres->mem[HEAP_SEG_TOP]) ;
    mres->mem[HEAP_SEG_TOP]=NULL ;
    mres->mem_size[HEAP_SEG_TOP]=0 ;
  }
  res=memal( mres, HEAP_SEG_TOP, default_heapsize, MEM_ATTR_NORMAL ) ;
  if( res!=NORMAL_EXIT ){
    SYSMSG("Can not allocate memory(seg=0x%02x size=%d)\n",
	   HEAP_SEG_TOP, default_heapsize ) ;
    return(MEM_ALLOC_ERROR) ;
  }

  
  if( mres->mem[BRK_SEG_TOP]!=NULL ){
    free(mres->mem[BRK_SEG_TOP]) ;
    mres->mem[BRK_SEG_TOP]=NULL ;
    mres->mem_size[BRK_SEG_TOP]=0 ;
  }
  res=memal( mres, BRK_SEG_TOP, default_brksize, MEM_ATTR_NORMAL ) ;
  if( res!=NORMAL_EXIT ){
    SYSMSG("Can not allocate memory(seg=0x%02x size=%d)\n",
	   BRK_SEG_TOP, default_brksize ) ;
    return(MEM_ALLOC_ERROR) ;
  }

  
  if( mres->mem[PCIIO_SEG_TOP]!=NULL ){
    free(mres->mem[PCIIO_SEG_TOP]) ;
    mres->mem[PCIIO_SEG_TOP]=NULL ;
    mres->mem_size[PCIIO_SEG_TOP]=0 ;
  }
  res=memal( mres, PCIIO_SEG_TOP, DEFAULT_PCIMEMSIZE, MEM_ATTR_SHARED) ;
  if( res!=NORMAL_EXIT ){
    SYSMSG("Can not allocate memory(seg=0x%02x size=%d)\n",
	   PCIIO_SEG_TOP, DEFAULT_PCIMEMSIZE ) ;
    return(MEM_ALLOC_ERROR) ;
  }
    
#ifdef SUPPORT_GRAPHIC_DEVICE
  if( mres->mem[GVRAM_SEG_TOP]!=NULL ){
    free(mres->mem[GVRAM_SEG_TOP]) ;
    mres->mem[GVRAM_SEG_TOP]=NULL ;
    mres->mem_size[GVRAM_SEG_TOP]=0 ;
  }
  res=memal( mres, GVRAM_SEG_TOP,
	     (GRAPHIC_VRAM_WIDTH*GRAPHIC_VRAM_DEPTH*GRAPHIC_SCREEN_HEIGHT), MEM_ATTR_SHARED ) ;
  if( res!=NORMAL_EXIT ){
    SYSMSG("Can not allocate memory(seg=0x%02x size=%d)\n",
	   GVRAM_SEG_TOP, (GRAPHIC_VRAM_WIDTH*GRAPHIC_VRAM_DEPTH*GRAPHIC_SCREEN_HEIGHT) ) ;
    return(MEM_ALLOC_ERROR) ;
  }
#endif

  init_regs( mres ) ;
  mres->heap_top      = default_heaptop ;
  mres->heap_size     = default_heapsize ;
  mres->heap_cur      = 0 ;
  mres->brk_top       = default_brktop ;
  mres->brk_size      = default_brksize ;
  mres->brk_cur       = 0 ;
  mres->pc            = default_exec_start ;
  mres->GPR[1].rl     = mres->mem_size[TEXT_SEG_TOP] - default_stack_top_offset ;
  mres->id            = id ;
  strcpy(mres->pname,"init") ;
  init_mman( mres ) ;

  return(NORMAL_EXIT) ;
}
