/**********************************************************************
  DISKfoCX}Eg
  $Id: mount_cmd.c,v 1.3 2002/11/03 03:57:35 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "funcs.h"
#include "processor.h"
#include "memory.h"
#include "op_exec.h"
#include "sim_io.h"

#define reverse_int(a)   (((a<<24)&0xff000000)|((a<<8)&0x00ff0000)|((a>>8)&0x0000ff00)|((a>>24)&0x000000ff))

#define MOUNT_MODE    0
#define UMOUNT_MODE   1

int	mount_cmd( struct TOKEN_STRUCT *tk_pt , int mode )
{
  int i ;
  int drv, tnum, tlen ;
  int res ;

  res=NORMAL_EXIT ;
  
  if( mode==MOUNT_MODE ){
    if( tk_pt->pt[1]==NULL ){
      for( i=0 ; i<SIM_DISK_DRIVE_NUM ; i++ ){
	if( simDisk[i].mount==VALID ){
	  SYSMSG("%3d  type=0x%08x track_len=0x%08x track_num=0x%08x\n",
		 i,
		 simDisk[i].type,
		 simDisk[i].tlen,
		 simDisk[i].tnum ) ;
	}
      }
    }else{
      drv=exatoi(tk_pt->pt[1]) ;
      if( simDisk[drv].mount==VALID ){
	SYSMSG("DISK %i is already mounted.\n",drv) ;
	res=SPECIFY_ERROR ;
      }else{
	if( tk_pt->pt[2]==NULL ){
	  SYSMSG("Specified invalid track length.\n") ;
	  res=SPECIFY_ERROR ;
	}else{
	  tlen=exatoi(tk_pt->pt[2]) ;
	  if( tlen<=0 ){
	    SYSMSG("Specified invalid track length(%d).\n",tlen) ;
	    res=SPECIFY_ERROR ;
	  }else{
	    if( tk_pt->pt[3]==NULL ){
	      SYSMSG("Specified invalid track number.\n") ;
	      res=SPECIFY_ERROR ;
	    }else{
	      tnum=exatoi(tk_pt->pt[3]) ;
	      if( tnum<=0 ){
		SYSMSG("Specified invalid track number(%d).\n",tnum) ;
		res=SPECIFY_ERROR ;
	      }else{
		simDisk[drv].info=malloc( sizeof(struct sim_disk_info_struct) ) ;
		if( simDisk[drv].info==NULL ){
		  SYSMSG("mount failed drive %d\n",drv) ;
		}
		simDisk[drv].buf =malloc( tnum * tlen ) ;
		if( simDisk[drv].buf ==NULL ){
		  free( simDisk[drv].info ) ;
		  SYSMSG("mount failed drive %d\n",drv) ;
		}else{
		  simDisk[drv].mount= VALID ;
		  simDisk[drv].type = ( DISK_TYPE_EN_READ | DISK_TYPE_EN_WRITE ) ;
		  simDisk[drv].tlen = tlen ;
		  simDisk[drv].tnum = tnum ;
		  memset( simDisk[drv].info->vender_id, 0, VENDER_ID_LEN ) ;
		  strcpy( simDisk[drv].info->vender_id , VENDER_ID ) ;
		  simDisk[drv].info->type = reverse_int( simDisk[drv].type ) ;
		  simDisk[drv].info->tnum = reverse_int( simDisk[drv].tnum ) ;
		  simDisk[drv].info->tlen = reverse_int( simDisk[drv].tlen ) ;
		  memset( simDisk[drv].info->pading, 0, DISK_INFO_PADING ) ;
		  memset( simDisk[drv].buf, 0, tlen * tnum ) ;
		}
	      }
	    }
	  }
	}
      }
    }
  }

  if( mode==UMOUNT_MODE ){
    if( tk_pt->pt[1]==NULL ){
      SYSMSG("Specified drive is not mounted.\n" ) ;
    }else{
      drv=exatoi(tk_pt->pt[1]) ;
      if( simDisk[drv].mount != VALID ){
	SYSMSG("Specific drive(%d) is not mounted .\n", drv ) ;
	res=SPECIFY_ERROR ;
      }else{
	simDisk[drv].mount= INVALID ;
	simDisk[drv].type = 0 ;
	simDisk[drv].tlen = 0 ;
	simDisk[drv].tnum = 0 ;
	free( simDisk[drv].info ) ;
	free( simDisk[drv].buf  ) ;
      }
    }
  }

  return(res) ;
}


